package com.incubator.game.data.model;

import com.incubator.game.player.Player;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 房间数据实体类
 * 作者：agui
 * 自动创建时间：2022-10-01 02:24:37
 */
public class RoomPO {
	/** 房间号 */
	public int roomId;
	/** 房间玩法类型 1:经典掼蛋 */
	public int type;
	/** 房主playerId **/
	public String ownerId = "";
	/** 最大人数 **/
	public int maxNum;
	/** 玩家id集合 [key:玩家id, value:玩家对象]**/
	public Map<String, Player> playerIds = new HashMap<>();
	/** 玩家 [key:座位号， value:玩家对象] **/
	public Map<Integer, Player> playerMap = new HashMap<>();

	/** 牌库 **/
	public List<Integer> cardList = new ArrayList<>();

	/** 检测标记 **/
	public boolean flag;
	/** 时间秒数 **/
	public int time;
	/** 房间状态(0等待 1开局 2进行中 3已结束) **/
	public int state;
	/** 当前局数 **/
	public int curRound;
	/** 庄家位置 **/
	public int zhuangPos;
	/** 当前操作玩家 **/
	public Player currentPlayer;
	/** 当前出牌玩家打出的牌集合 **/
	public int[] curDisCardList = new int[]{};
	/** 当前出牌的玩家 **/
	public Player disCardPlayer;

	/** 结算列表[key:1-4游, value:玩家id] **/
	public Map<Integer, String> result = new HashMap<>();

	public RoomPO() {}

	public void init() {

	}
}
