package com.incubator.game.listener;

import com.incubator.core.net.ws.*;
import com.incubator.game.GGame;
import com.incubator.common.net.Connection;
import com.incubator.message.GameRegMsg;
import com.incubator.message.proto.CommonProto;
import com.incubator.core.net.handler.listener.GameClientConnectionListener;
import io.netty.buffer.ByteBuf;

/**
 * 中控服消息
 * @author johnc
 *
 */
public class CenterClientListener extends GameClientConnectionListener {

	@Override
	public void connectionOpened(Connection conn) {
		logger.info("中控服链路打开发送注册,注册码:{}", CommonProto.Cmd.S2S_GAME_REG_VALUE);
        try {
            GameRegMsg.GameRegG2C gameRegG2C = new GameRegMsg.GameRegG2C();
            gameRegG2C.setServerId(GGame.SERVER_ID);
            gameRegG2C.setHost(GGame.BIND_HOST);
            gameRegG2C.setPort(GGame.BIND_PORT);
//          Message msg = new Message(ProtoCommon.MsgId.S2S_GAME_REG, gameRegG2C.toJson());
//          conn.writeAndFlush(super.packMessage(msg));
        } catch (Exception e) {
			logger.info("游戏服注册出错：{}", e.getMessage());
        }

//		conn.writeAndFlush(new TextWebSocketFrame(msg.toJson()));
	}

	@Override
	public void connectionClosed(Connection conn) {
		GGame.isRegCenter = false;
	}

	@Override
	public void messageArrived(Connection conn, Object msg) {
		try {
			if (msg instanceof ByteBuf) {
				ByteBuf byteBuf = (ByteBuf) msg;

				byte[] bytes = new byte[byteBuf.readableBytes()];
				byteBuf.readBytes(bytes);

				WSRequest request = new WSRequest(bytes);

				NetHandler handler = GGame.handlers.get(request.getCmd());
				if (handler != null) {
					logger.info("收到消息 : cmd={}, 请求内容 : {}", request.getCmd(), request.toJson());
					WSResponse response = new WSResponse();
					handler.onDate(conn, request, response);
					logger.info("返回消息 : cmd={}, 返回内容 : {}", request.getCmd(), response.toJson());
				} else {
					logger.info("消息号错误... cmd={}", request.getCmd());
				}
			}
		} catch (Exception e) {
			logger.error("...数据解析有错...");
		}
	}

	@Override
	public boolean doIsHeartReq(Object msg) {
//		try {
//			byte[] bytes = new byte[msg.content().readableBytes()];
//			msg.content().readBytes(bytes);
//			MessageUnpacker unpacker = MessagePack.newDefaultUnpacker(bytes);
//			WSRequest request = super.parseWSRequest(unpacker);
//			return request.getMsgId() == ProtoCommon.MsgId.S2C_Heartbeat_VALUE;
//		} catch (Exception e) {
//			logger.error("心跳请求解析失败", e);
//			return false;
//		}

		return false;

//		String text = msg.text();
//		MsgBase request = JSON.parseObject(text, MsgBase.class);
//		return request.getMsgId() == ProtoCommon.MsgId.S2C_Heartbeat_VALUE;
	}

	@Override
	public void doSendHeartReq(Connection conn) {
        try {
//            HeartbeatPush push = new HeartbeatPush();
//            push.setTime(System.currentTimeMillis());
//            Message msg = new Message(ProtoCommon.MsgId.S2C_Heartbeat, push.toJson());
//            msg.setCode(ProtoCommon.Code.OK_VALUE);
//            conn.writeAndFlush(super.packMessage(msg));
        } catch (Exception e) {
			logger.info("发送心跳请求出错：" + conn.getUid() + e.getMessage());
        }

//		conn.writeAndFlush(new TextWebSocketFrame(msg.toJson()));
	}

	@Override
	public void doSendHeartRsp(Connection conn) {
//		HeartbeatPush push = new HeartbeatPush();
//		push.setTime(System.currentTimeMillis());
//		Message msg = new Message(ProtoCommon.MsgId.S2C_Heartbeat, push.toJson());
//		msg.setCode(ProtoCommon.Code.OK_VALUE);
//		conn.writeAndFlush(new TextWebSocketFrame(msg.toJson()));
	}

}
